# This file is processed when the Renesas C Compiler is used
#
# CPU <arch> supported in CMake: RX, RL78 and RH850
#
# The compiler user documentation is architecture-dependent
# and it can found with the product installation under Help/Compiler-CC{RX, RL, RH}.chm
#
#
include_guard()

#macro(__compiler_iar_ilink lang)
#  set(CMAKE_EXECUTABLE_SUFFIX ".elf")
#  set(CMAKE_${lang}_OUTPUT_EXTENSION ".o")
#  if (${lang} STREQUAL "C" OR ${lang} STREQUAL "CXX")
#    set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -o <OBJECT>")
#    set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> --preprocess=cnl <PREPROCESSED_SOURCE>")
#    set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -lAH <ASSEMBLY_SOURCE> -o <OBJECT>.dummy")
#
#    set(CMAKE_${lang}_RESPONSE_FILE_LINK_FLAG "-f ")
#    set(CMAKE_DEPFILE_FLAGS_${lang} "--dependencies=ns <DEP_FILE>")
#
#    string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
#    string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -r")
#    string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -Ohz -DNDEBUG")
#    string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -Oh -DNDEBUG")
#    string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -Oh -r -DNDEBUG")
#  endif()
#
#  set(CMAKE_${lang}_LINK_EXECUTABLE "<CMAKE_LINKER> --silent <OBJECTS> <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <LINK_LIBRARIES> -o <TARGET>")
#  set(CMAKE_${lang}_CREATE_STATIC_LIBRARY "<CMAKE_AR> <TARGET> --create <LINK_FLAGS> <OBJECTS>")
#  set(CMAKE_${lang}_ARCHIVE_CREATE "<CMAKE_AR> <TARGET> --create <LINK_FLAGS> <OBJECTS>")
#  set(CMAKE_${lang}_ARCHIVE_APPEND "<CMAKE_AR> <TARGET> --replace <LINK_FLAGS> <OBJECTS>")
#  set(CMAKE_${lang}_ARCHIVE_FINISH "")
#endmacro()

#macro(__compiler_iar_xlink lang)
#  set(CMAKE_EXECUTABLE_SUFFIX ".bin")
#  if (${lang} STREQUAL "C" OR ${lang} STREQUAL "CXX")
#
#    set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -o <OBJECT>")
#    set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> --preprocess=cnl <PREPROCESSED_SOURCE>")
#    set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -lAH <ASSEMBLY_SOURCE> -o <OBJECT>.dummy")
#
#    set(CMAKE_${lang}_RESPONSE_FILE_LINK_FLAG "-f ")
#    set(CMAKE_DEPFILE_FLAGS_${lang} "--dependencies=ns <DEP_FILE>")
#
#    string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
#    string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -r")
#    string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -Ohz -DNDEBUG")
#    string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -Oh -DNDEBUG")
#    string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -Oh -r -DNDEBUG")
#  endif()
#
#  set(CMAKE_${lang}_LINK_EXECUTABLE "<CMAKE_LINKER> -S <OBJECTS> <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <LINK_LIBRARIES> -o <TARGET>")
#  set(CMAKE_${lang}_CREATE_STATIC_LIBRARY "<CMAKE_AR> <TARGET> <LINK_FLAGS> <OBJECTS>")
#  set(CMAKE_${lang}_ARCHIVE_CREATE "<CMAKE_AR> <TARGET> <LINK_FLAGS> <OBJECTS>")
#  set(CMAKE_${lang}_ARCHIVE_APPEND "")
#  set(CMAKE_${lang}_ARCHIVE_FINISH "")
#
#  set(CMAKE_LIBRARY_PATH_FLAG "-I")
#endmacro()

macro(__compiler_renesas lang)
  set(CMAKE_EXECUTABLE_SUFFIX ".abs")
  set(CMAKE_${lang}_OUTPUT_EXTENSION ".obj")
  if (${lang} STREQUAL "C" OR ${lang} STREQUAL "CXX")
    if(0)
      set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -o <OBJECT>")
      set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> --preprocess=cnl <PREPROCESSED_SOURCE>")
      set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> ${CMAKE_IAR_${lang}_FLAG} --silent <SOURCE> <DEFINES> <INCLUDES> <FLAGS> -lAH <ASSEMBLY_SOURCE> -o <OBJECT>.dummy")
    endif()
    if("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RX")
      set(CMAKE_INCLUDE_FLAG_${lang} "-include=")
      set(CMAKE_DEFINE_FLAG_${lang} "-define=")
      # Note: <FLAGS> includes CMAKE_${lang}_FLAGS, CMAKE_${lang}_FLAGS_<config> and `lang standard option(s)`
      # FIXME: Should ${RENESAS_${lang}_FLAGS} be used?
      set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> -nologo ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -output=obj=<OBJECT> <SOURCE>")
      set(CMAKE_${lang}_DEPENDS_EXTRA_COMMANDS     "<CMAKE_${lang}_COMPILER> -nologo ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -MM -MT=<OBJECT> -output=dep=<DEP_FILE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> -nologo ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -output=prep=<PREPROCESSED_SOURCE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> -nologo ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -output=src=<ASSEMBLY_SOURCE> <SOURCE>")
    elseif("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RL78")
      set(CMAKE_DEFINE_FLAG_ASM "-D") # This is the same as default setting.
      set(CMAKE_INCLUDE_FLAG_ASM "-I") # This is the same as default setting.
      # Note: <FLAGS> includes CMAKE_${lang}_FLAGS, CMAKE_${lang}_FLAGS_<config> and `lang standard option(s)`
      # FIXME: Should ${RENESAS_${lang}_FLAGS} be used?
      set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -c -o <OBJECT> <SOURCE>")
      set(CMAKE_${lang}_DEPENDS_EXTRA_COMMANDS     "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -M -MT=<OBJECT> -o <DEP_FILE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -P -o <PREPROCESSED_SOURCE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -S -o <ASSEMBLY_SOURCE> <SOURCE>")
    elseif("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RH850")
      set(CMAKE_DEFINE_FLAG_ASM "-D") # This is the same as default setting.
      set(CMAKE_INCLUDE_FLAG_ASM "-I") # This is the same as default setting.
      # Note: <FLAGS> includes CMAKE_${lang}_FLAGS, CMAKE_${lang}_FLAGS_<config> and `lang standard option(s)`
      # FIXME: Should ${RENESAS_${lang}_FLAGS} be used?
      set(CMAKE_${lang}_COMPILE_OBJECT             "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -c -o<OBJECT> <SOURCE>")
      set(CMAKE_${lang}_DEPENDS_EXTRA_COMMANDS     "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -M -MT=<OBJECT> -Xno_warning=11123 -o<DEP_FILE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_PREPROCESSED_SOURCE "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -P -o<PREPROCESSED_SOURCE> <SOURCE>")
      set(CMAKE_${lang}_CREATE_ASSEMBLY_SOURCE     "<CMAKE_${lang}_COMPILER> ${RENESAS_${lang}_FLAGS} <DEFINES> <INCLUDES> <FLAGS> -S -o<ASSEMBLY_SOURCE> <SOURCE>")
    endif()
 
    if(0)
    set(CMAKE_${lang}_RESPONSE_FILE_LINK_FLAG "-f ")
    set(CMAKE_DEPFILE_FLAGS_${lang} "--dependencies=ns <DEP_FILE>")
    endif()
    set(CMAKE_${lang}_RESPONSE_FILE_LINK_FLAG "-subcommand=") # FIXME: -Input= is necessary...
    #set(CMAKE_DEPFILE_FLAGS_${lang} "--dependencies=ns <DEP_FILE>") # FIXME

    if(0)
      string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
      string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -r")
      string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -Ohz -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -Oh -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -Oh -r -DNDEBUG")
      endif()
    if("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RX")
      # -g_line is available for CC-RX V3.02 or later
      string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
      string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -optimize=0 -debug -g_line")
      string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -optimize=2 -size -define=NDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -optimize=2 -define=NDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -optimize=2 -debug -g_line -define=NDEBUG")
    elseif("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RL78")
      # -g_line is available for CC-RL V1.02 or later
      string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
      string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -Onothing -g -g_line")
      string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -Osize -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -Odefault -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -Odefault -g -g_line -DNDEBUG")
    elseif("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RH850")
      # -g_line is available for CC-RH V1.05 or later
      string(APPEND CMAKE_${lang}_FLAGS_INIT " ")
      string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -Onothing -g -g_line")
      string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -Osize -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -Odefault -DNDEBUG")
      string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -Odefault -g -g_line -DNDEBUG")
    endif()

    set(CMAKE_${lang}_COMPILE_OPTIONS_TARGET " ") # FIXME
  endif()

  if(0)
  set(CMAKE_${lang}_LINK_EXECUTABLE "<CMAKE_LINKER> --silent <OBJECTS> <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <LINK_LIBRARIES> -o <TARGET>")
  set(CMAKE_${lang}_CREATE_STATIC_LIBRARY "<CMAKE_AR> <TARGET> --create <LINK_FLAGS> <OBJECTS>")
  set(CMAKE_${lang}_ARCHIVE_CREATE "<CMAKE_AR> <TARGET> --create <LINK_FLAGS> <OBJECTS>")
  set(CMAKE_${lang}_ARCHIVE_APPEND "<CMAKE_AR> <TARGET> --replace <LINK_FLAGS> <OBJECTS>")
  set(CMAKE_${lang}_ARCHIVE_FINISH "")
  endif()
  set(CMAKE_LIBRARY_PATH_FLAG "") # FIXME
  set(CMAKE_LINK_LIBRARY_FLAG "-library=")
  # Note: <LINK_FLAGS> includes ${CMAKE_EXE_LINKER_FLAGS}
  if(RENESAS_XCONVERTER)
    if("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RX")
      set(CMAKE_${lang}_LINK_EXECUTABLE
        "<CMAKE_COMMAND> -E echo Library Generator:"
        "\"${RENESAS_LIBRARY_GENERATOR}\" -nologo ${RENESAS_LIBRARY_GENERATOR_${lang}_FLAGS} -output=<TARGET>.lib"
        "<CMAKE_COMMAND> -E echo Linker:"
        "<CMAKE_LINKER> -nologo <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> <LINK_LIBRARIES> -library=<TARGET>.lib -form=abs -output=<TARGET>"
        "<CMAKE_COMMAND> -E echo X Converter:"
        "\"${RENESAS_XCONVERTER}\" <TARGET> <TARGET>.x ${RENESAS_XCONVERTER_FLAGS}"
      )
    else()
      set(CMAKE_${lang}_LINK_EXECUTABLE
        "<CMAKE_COMMAND> -E echo Linker:"
        "<CMAKE_LINKER> -nologo <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> <LINK_LIBRARIES> -form=abs -output=<TARGET>"
        "<CMAKE_COMMAND> -E echo X Converter:"
        "\"${RENESAS_XCONVERTER}\" <TARGET> <TARGET>.x ${RENESAS_XCONVERTER_FLAGS}"
      )
    endif()
  else()
    if("${CMAKE_${lang}_COMPILER_ARCHITECTURE_ID}" STREQUAL "RX")
      set(CMAKE_${lang}_LINK_EXECUTABLE
        "<CMAKE_COMMAND> -E echo Library Generator:"
        "\"${RENESAS_LIBRARY_GENERATOR}\" -nologo ${RENESAS_LIBRARY_GENERATOR_${lang}_FLAGS} -output=<TARGET>.lib"
        "<CMAKE_COMMAND> -E echo Linker:"
        "<CMAKE_LINKER> -nologo <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> <LINK_LIBRARIES> -library=<TARGET>.lib -form=abs -output=<TARGET>"
      )
    else()
      set(CMAKE_${lang}_LINK_EXECUTABLE
        "<CMAKE_COMMAND> -E echo Linker:"
        "<CMAKE_LINKER> -nologo <CMAKE_${lang}_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> <LINK_LIBRARIES> -form=abs -output=<TARGET>"
      )
    endif()
  endif()
  set(CMAKE_${lang}_CREATE_STATIC_LIBRARY "<CMAKE_AR> -nologo <LINK_FLAGS> <OBJECTS> -form=lib -output=<TARGET>")
  set(CMAKE_${lang}_ARCHIVE_CREATE "<CMAKE_AR> -nologo <LINK_FLAGS> <OBJECTS> -form=lib -output=<TARGET>")
  set(CMAKE_${lang}_ARCHIVE_APPEND "")
  set(CMAKE_${lang}_ARCHIVE_FINISH "")

  # TODO: The following option may depend on CC-RX, CC-RL, CC-RH
  string(APPEND CMAKE_EXE_LINKER_FLAGS_INIT " ")
  string(APPEND CMAKE_EXE_LINKER_FLAGS_DEBUG_INIT " -debug")
  string(APPEND CMAKE_EXE_LINKER_FLAGS_MINSIZEREL_INIT " ")
  string(APPEND CMAKE_EXE_LINKER_FLAGS_RELEASE_INIT " ")
  string(APPEND CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO_INIT " -debug")
endmacro()
